import { reactAsyncIterSpecialInfoSymbol, } from '../common/ReactAsyncIterable.js';
import { asyncIterSyncMap } from '../common/asyncIterSyncMap.js';
import { isAsyncIter } from '../common/isAsyncIter.js';
export { iterateFormatted };
function iterateFormatted(source, formatFn) {
    if (!isAsyncIter(source)) {
        return formatFn(source, 0);
    }
    const sourceSpecialInfo = source?.[reactAsyncIterSpecialInfoSymbol];
    return {
        [Symbol.asyncIterator]: () => asyncIterSyncMap(source, formatFn)[Symbol.asyncIterator](),
        [reactAsyncIterSpecialInfoSymbol]: !sourceSpecialInfo
            ? {
                origSource: source,
                formatFn,
            }
            : {
                origSource: sourceSpecialInfo.origSource,
                formatFn: (value, i) => {
                    const prevMapResult = sourceSpecialInfo.formatFn(value, i);
                    return formatFn(prevMapResult, i);
                },
            },
    };
}
//# sourceMappingURL=index.js.map